QGIS Application - Bug report #16419
Virtual layers SQL output fields without alias raise errors
2017-04-07 12:06 AM - Giovanni Allegri

Status: Feedback

Priority: Normal

Assignee:

Category: DB Manager
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 24328
Description

Calculated fields inside Virtual Layers SQL queries (through DB Manager) must have an alias otherwise it raises errors.
The problem is that it can't be deduced from the error message.

As an example:
SELECT
ST_Area("landcover"."geometry")

FROM "landcover"

will raise the message "Query preparation error on SELECT "ST_Area("comuni"."geometry")" FROM _tview LIMIT 1: near "."": syntax
error"

(you can see it in the vlayer.png image attachment)
The query works fine if an alias is added:
SELECT

ST_Area("landcover"."geometry") AS area

FROM "landcover"

I guess that the fix could be to use the field function as a string and use it for the output field name (as DBs do)

History

#1 - 2017-05-01 01:01 AM - Giovanni Manghi
- Easy fix? set to No

- Regression? set to No

#2 - 2019-03-09 04:28 PM - Giovanni Manghi
- Status changed from Open to Feedback

Please check if this issue is still valid on QGIS 3.4.5 or 3.6.
